#include "itext.h"
#include "./unzip/unzip.h"

static int _unzipLog(char *s)
{
	FILE *fp;

	fp = fopen("./unzip.log","a");

	fprintf(fp,"%s\n",s);

	fclose(fp);

	return 0;
}
int itextGetZipTitle(char *file_path,unsigned char *title,unsigned char *person)
{
	char log[100];
	char filename[256];

	void *un_buf;
	int un_size;

	unzFile *fz;
	unz_global_info ginfo;
	unz_file_info finfo;

	int i,j,k,flag;
	unsigned char *p,*u,temp[10][BUFSIZ];
	ftype_t ftype;


	if((fz = unzOpen(file_path)) == NULL){
		sprintf(log,"unzip : False Open File %s",file_path);
		_unzipLog(log);
		return -1;
	}

	if(unzGetGlobalInfo(fz,&ginfo) != UNZ_OK){
		_unzipLog("unzip : False unzGetGloblInfo()");
		return -1;
	}

	if(unzGoToFirstFile(fz) != UNZ_OK){
		_unzipLog("unzip : False unzGoToFirstFile()");
		return -1;
	}


	for(i=0;i<ginfo.number_entry;i++){

		unzGetCurrentFileInfo(fz,&finfo,filename,256,NULL,0,NULL,0);

		if((ftype = itextCheckFileType_ex(filename)) == F_TXT){

			unzOpenCurrentFile(fz);

			un_buf = (void *)malloc(BUFSIZ);
			while((un_size = unzReadCurrentFile(fz,un_buf,BUFSIZ)) > 0){

				k = 0;
				j = 0;
				flag = 0;
				for(u=un_buf;*u;u++){
					if(*u != '\n') k++;
					if(*u == '\n'){
						if(k==0) continue;
						if(j<2) break;

						temp[flag][j] = '\0';

						if(strncmp(temp[flag],"----------",10) == 0) break;
						if(flag++ >= 10) break;

						j = 0;
						continue;
					}
					if(k>0) temp[flag][j++] = *u;
				}
				temp[flag][j] = '\0';

				break;
			}
			for(p=temp[0],j=0;*p;p++,j++){
				if(*p == '\r' || j >= 127){
				       	*p = '\0';
					break;
				}
			}
			if(temp[0][0] == '\0')
				strcpy(title,"");
			else
				strcpy(title,temp[0]);

			for(p=temp[flag-1],j=0;*p;p++,j++){
				if(*p == '\r' || j >= 127){
				       	*p = '\0';
					break;
				}
			}
			if(temp[flag-1][0] == '\0')
				strcpy(person,"");
			else
				strcpy(person,temp[flag-1]);

			free(un_buf);
			unzCloseCurrentFile(fz);

			break;

		}
		unzGoToNextFile(fz);
	}
	unzClose(fz);


	return 1;
}
