#include "itext.h"
#include "xtext.h"
#include <dirent.h>


sub_window_t * subwindow_data_alloc()
{
	sub_window_t *sw;

	sw = (sub_window_t *)malloc(sizeof(sub_window_t));
	sw->line_str = NULL;
	sw->line_data = NULL;
	sw->re_str = NULL;
	sw->func = NULL;
	sw->func_data0 = NULL;
	sw->func_data1 = -1;
	sw->type = XJP_NONE;
	sw->line_no = -1;
	sw->mdata = 0;
	sw->mstr = 0;

	return sw;
}
void * subwindow_data_free(sub_window_t **head,sub_window_t **tail)
{
	sub_window_t *sw,*sww;

	if(*head == NULL) return NULL;

	for(sw = *head;sw!=NULL;sw=sww){
		sww = sw->next;

		if(sw->mstr && sw->line_str != NULL) free(sw->line_str);
		if(sw->mdata && sw->line_data != NULL) free(sw->line_data);

		free(sw);
	}

	*head = NULL;
	*tail = NULL;

	return NULL;
}
void * subwindow_data_add(sub_window_t **head,sub_window_t **tail,sub_window_t *im)
{
	if(*tail){
                im->next = NULL;
                im->prev = *tail;

                (*tail)->next = im;
                *tail = im;
        }else{
                im->next = NULL;
                im->prev = NULL;

                *tail = im;
                *head = im;
        }

        return NULL;
}

void subwindow_data_insert(	sub_window_t **head,
					sub_window_t **tail,
					char *line_str,
					char *line_data,
					char *re_str,
					int (*func)(),
					void * data0,
					int data1,
					int type,
					int line_no	)
{
	sub_window_t *sw;

	sw = (sub_window_t *)subwindow_data_alloc();

	if(line_str != NULL){
		sw->line_str=(char *)malloc(strlen(line_str)+1);
		strcpy(sw->line_str,line_str);
		sw->mstr = 1;
	}

	sw->line_data = line_data;

	if(re_str != NULL){
		sw->re_str = (char *)malloc(strlen(re_str)+1);
		strcpy(sw->re_str,re_str);
	}

	sw->func = func;
	sw->func_data0 = data0;
	sw->func_data1 = data1;
	sw->line_no = line_no;
	sw->type = type;

	subwindow_data_add(head,tail,sw);

	return ;
}
int xtextHelpData2Sub(sub_window_t **head,sub_window_t **tail,xtext_conf_t *xconf)
{
	other_prog_t *op;

	char line_str[128];
	void *line_data,*data0;
	int data1;
	int type;
	int i = 1;

	if(*head != NULL) subwindow_data_free(head,tail);

	strcpy(line_str,T_NAME);
	line_data = NULL;
	data0 = NULL;
	data1 = XJP_NONE;
	type = XJP_NONE;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,NULL,data0,data1,type,i++);

	strcpy(line_str,"(λ:ѹȿǤ)");
	line_data = NULL;
	data0 = (char *)XJP_OK;
	data1 = XJP_NONE;
	type = XJP_NONE;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_quit,data0,data1,type,i++);

	strcpy(line_str,"(Cancel:ѹȿǤʤ)");
	line_data = NULL;
	data0 = (char *)XJP_CANCEL;
	data1 = XJP_NONE;
	type = XJP_NONE;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_quit,data0,data1,type,i++);

	strcpy(line_str,"(¸:ߤ¸)");
	line_data = NULL;
	data0 = (xtext_conf_t *)xconf;
	data1 = XJP_NONE;
	type = XJP_NONE;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_save,data0,data1,type,i++);

	subwindow_data_insert(head,tail,"-- ѹ-- ",NULL,NULL,NULL,NULL,XJP_NONE,XJP_NONE,i++);


       	strcpy(line_str,"¸ʸ:");
	line_data = xconf->book_dir;
	data0 = NULL;
	data1 = XJP_NONE;
	type = XJP_NONE;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,NULL,data0,data1,type,i++);
	for(op=xconf->other_head;op!=NULL;op=op->next){
       		strcpy(line_str,"¾ץ:");
		line_data = op->exec;
		data0 = NULL;
		data1 = XJP_NONE;
		type = XJP_NONE;
		subwindow_data_insert(head,tail,line_str,line_data,NULL,NULL,data0,data1,type,i++);
	}

	sprintf(line_str,"[]");
	line_data = NULL;
	data0 = NULL;
	data1 = XJP_NONE;
	type = XJP_NONE;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,NULL,data0,data1,type,i++);

	strcpy(line_str,"ڡ:");
	line_data = xconf->page_next;
	data0 = (char *)xconf->page_next;
	data1 = XJP_CHA;
	type = XJP_CHA;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);


	strcpy(line_str,"ڡ:");
	line_data = xconf->page_prev;
	data0 = (char *)xconf->page_prev;
	data1 = XJP_CHA;
	type = XJP_CHA;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str,"ڡ:");
	line_data = xconf->conf_page;
	data0 = (char *)xconf->conf_page;
	data1 = XJP_CHA;
	type = XJP_CHA;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str,"ٵϿ:");
	line_data = xconf->book_mark;
	data0 = (char *)xconf->book_mark;
	data1 = XJP_CHA;
	type = XJP_CHA;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str,"٥˥塼:");
	line_data = xconf->siori_menu;
	data0 = (char *)xconf->siori_menu;
	data1 = XJP_CHA;
	type = XJP_CHA;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str,"˥塼:");
	line_data = xconf->menu;	
	data0 = (char *)xconf->menu;
	data1 = XJP_CHA;
	type = XJP_CHA;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str,"λ:");
	line_data = xconf->quit;
	data0 = (char *)xconf->quit;
	data1 = XJP_CHA;
	type = XJP_CHA;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str,"ȥON-OFF:");
	line_data = xconf->title_key;
	data0 = (char *)xconf->title_key;
	data1 = XJP_CHA;
	type = XJP_CHA;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str,"ǡɽON-OFF:");
	line_data = xconf->page_key;
	data0 = (char *)xconf->page_key;
	data1 = XJP_CHA;
	type = XJP_CHA;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str,"٥ѹ:");
	line_data = xconf->kinsc_key;
	data0 = (char *)xconf->kinsc_key;
	data1 = XJP_CHA;
	type = XJP_CHA;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str,"ɥON-OFF:");
	line_data = xconf->chuki_key;
	data0 = (char *)xconf->chuki_key;
	data1 = XJP_CHA;
	type = XJP_CHA;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str,"ɲ:");
	line_data = xconf->net_key;
	data0 = (char *)xconf->net_key;
	data1 = XJP_CHA;
	type = XJP_CHA;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str,"ڴ:");
	line_data = xconf->cursor_key;
	data0 = (char *)xconf->cursor_key;
	data1 = XJP_CHA;
	type = XJP_CHA;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str,"¾źեե:");
	line_data = xconf->other_key;
	data0 = (char *)xconf->other_key;
	data1 = XJP_CHA;
	type = XJP_CHA;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str,"FINDϲ:");
	line_data = xconf->find_key;
	data0 = (char *)xconf->find_key;
	data1 = XJP_CHA;
	type = XJP_CHA;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str,"FINDڡ:");
	line_data = xconf->find_next;
	data0 = (char *)xconf->find_next;
	data1 = XJP_CHA;
	type = XJP_CHA;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str,"FINDڡ:");
	line_data = xconf->find_prev;
	data0 = (char *)xconf->find_prev;
	data1 = XJP_CHA;
	type = XJP_CHA;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str,"[ɥ]");
	line_data = NULL;
	data0 = NULL;
	data1 = XJP_NONE;
	type = XJP_NONE;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,NULL,data0,data1,type,i++);

	sprintf(line_str,"ɥ: %d",xconf->main_window_width);
	line_data = NULL;
	data0 = NULL;
	data1 = XJP_NONE;
	type = XJP_NONE;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,NULL,data0,data1,type,i++);

	sprintf(line_str,"ɥ: %d",xconf->main_window_height);
	line_data = NULL;
	data0 = NULL;
	data1 = XJP_NONE;
	type = XJP_NONE;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,NULL,data0,data1,type,i++);

	strcpy(line_str,"طʿ:");
	line_data = xconf->main_window_color;
	data0 = (char *)xconf->main_window_color;
	data1 = XJP_COL;
	type = XJP_COL;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str,"ᥤʸ:");
	line_data = xconf->main_font_color;
	data0 = (char *)xconf->main_font_color;
	data1 = XJP_COL;
	type = XJP_COL;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str,"FINDʸ:");
	line_data = xconf->find_font_color;
	data0 = (char *)xconf->find_font_color;
	data1 = XJP_COL;
	type = XJP_COL;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str,"ʸ:");
	line_data = xconf->rubi_font_color;
	data0 = (char *)xconf->rubi_font_color;
	data1 = XJP_COL;
	type = XJP_COL;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str,"˥塼طʿ:");
	line_data = xconf->menu_window_color;
	data0 = (char *)xconf->menu_window_color;
	data1 = XJP_COL;
	type = XJP_COL;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str,"˥塼ʸ:");
	line_data = xconf->menu_font_color;
	data0 = (char *)xconf->menu_font_color;
	data1 = XJP_COL;
	type = XJP_COL;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str,"ʸƿ:");
	line_data = xconf->main_shadow_color;
	data0 = (char *)xconf->main_shadow_color;
	data1 = XJP_COL;
	type = XJP_COL;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str," طʿ:");
	line_data = xconf->select_window_color;
	data0 = (char *)xconf->select_window_color;
	data1 = XJP_COL;
	type = XJP_COL;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str," ʸ:");
	line_data = xconf->select_font_color;
	data0 = (char *)xconf->select_font_color;
	data1 = XJP_COL;
	type = XJP_COL;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str," :");
	line_data = xconf->select_font_background_color;
	data0 = (char *)xconf->select_font_background_color;
	data1 = XJP_COL;
	type = XJP_COL;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);
	strcpy(line_str,"[ե]");
	line_data = NULL;
	data0 = NULL;
	data1 = XJP_NONE;
	type = XJP_NONE;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,NULL,data0,data1,type,i++);

	strcpy(line_str,"ե(J):");
	line_data = xconf->main_font_j;
	data0 = (char *)xconf->main_font_j;
	data1 = XJP_FONT;
	type = XJP_FONT;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str,"ե(small):");
	line_data = xconf->main_font_s;
	data0 = (char *)xconf->main_font_s;
	data1 = XJP_FONT;
	type = XJP_FONT;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str,"ե(E):");
	line_data = xconf->main_font_e;
	data0 = (char *)xconf->main_font_e;
	data1 = XJP_FONT;
	type = XJP_FONT;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str,"ӥե:");
	line_data = xconf->rubi_font;
	data0 = (char *)xconf->rubi_font;
	data1 = XJP_FONT;
	type = XJP_FONT;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str,"Դ:");
	line_data = &(xconf->line_space);
	data0 = (int *)&xconf->line_space;
	data1 = XJP_INT;
	type = XJP_INT;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str,"ʸ:");
	line_data = &(int)(xconf->row_space);
	data0 = (int *)&xconf->row_space;
	data1 = XJP_INT;
	type = XJP_INT;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str,"[]");
	line_data = NULL;
	data0 = NULL;
	data1 = XJP_NONE;
	type = XJP_NONE;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,NULL,data0,data1,type,i++);

	strcpy(line_str,"ꥢ:");
	line_data = (int *)&xconf->anti;
	data0 = (int *)&xconf->anti;
	data1 = XJP_INT;
	type = XJP_INT;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str,"ȥɽ:");
	line_data = (int *)&xconf->title_on;
	data0 = (int *)&xconf->title_on;
	data1 = XJP_INT;
	type = XJP_INT;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str,"ǡɽ:");
	line_data = (int *)&xconf->page_on;
	data0 = (int *)&xconf->page_on;
	data1 = XJP_INT;
	type = XJP_INT;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str,"٥:");
	line_data = (int *)&xconf->kinsc;
	data0 = (int *)&xconf->kinsc;
	data1 = XJP_INT;
	type = XJP_INT;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str,"ɥɽ:");
	line_data = (int *)&xconf->chuki;
	data0 = (int *)&xconf->chuki;
	data1 = XJP_INT;
	type = XJP_INT;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str,":");
	line_data = (int *)&xconf->cursor;
	data0 = (int *)&xconf->cursor;
	data1 = XJP_INT;
	type = XJP_INT;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	strcpy(line_str,"Ĺ:");
	line_data = (int *)&xconf->max_line;
	data0 = (int *)&xconf->max_line;
	data1 = XJP_INT;
	type = XJP_INT;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);

	/*
	strcpy(line_str,"ɽ:");
	line_data = (int *)&xconf->ruby_on;
	data0 = (int *)&xconf->ruby_on;
	data1 = XJP_INT;
	type = XJP_INT;
	subwindow_data_insert(head,tail,line_str,line_data,NULL,xtext_conf_change,data0,data1,type,i++);
	*/

	return 0;
}
int xtextSioriData2Sub(sub_window_t **head,sub_window_t **tail,ISIORI_T *s_head)
{
	sub_window_t *sw;
	ISIORI_T *si;
	int i;

	if(s_head == NULL) return -1;
	if(*head != NULL) subwindow_data_free(head,tail);

	subwindow_data_insert(head,tail,T_NAME,NULL,NULL,NULL,NULL,XJP_NONE,XJP_NONE,1);
	subwindow_data_insert(head,tail,"(󥻥 q)",NULL,NULL,xtext_conf_quit,(char *)XJP_CANCEL,XJP_NONE,XJP_NONE,2);
	subwindow_data_insert(head,tail,"-- ١--",NULL,NULL,NULL,NULL,XJP_NONE,XJP_NONE,3);

	for(si=s_head,i=4;si!=NULL;si=si->next,i++){
		sw = (sub_window_t *) subwindow_data_alloc();

		sw->line_str = si->book_title;
		sw->line_data = si->book_time;
		sw->re_str = si->book_path;
		sw->func_data1 = XJP_STR;
		sw->line_no = i;

		subwindow_data_add(head,tail,sw);
	}

	return 0;
}
int xtextPerson2Sub(sub_window_t **head,sub_window_t **tail,IPERSON_T *phead)
{
	IPERSON_T *ip;
	sub_window_t *sw;
	int i;

	if(*head != NULL) subwindow_data_free(head,tail);

	subwindow_data_insert(head,tail,T_NAME,NULL,NULL,NULL,NULL,XJP_NONE,XJP_NONE,1);

	subwindow_data_insert(head,tail,"(¸޽ )",NULL,NULL,xtext_conf_quit,(char *)XJP_CANCEL,XJP_NONE,XJP_NONE,2);

	subwindow_data_insert(head,tail,"-- ¸޽ ̡--",NULL,NULL,NULL,NULL,XJP_NONE,XJP_NONE,4);

	for(ip=phead,i=5;ip!=NULL;ip=ip->next,i++){

		sw = (sub_window_t *) subwindow_data_alloc();
		sw->line_str = ip->person;
		sw->line_data = &(ip->no);
		sw->type = XJP_INT;
		sw->func = select_book_data;
		sw->func_data0 = (IBOOK_T *)ip->head;
		sw->func_data1 = 1;
		sw->line_no = i;
		subwindow_data_add(head,tail,sw);

	}

	return 0;
}
int xtextBookData2Sub(sub_window_t **head,sub_window_t **tail,IBOOK_T *bhead,int type)
{
	sub_window_t *sw;
	IBOOK_T *ib;
	int i = 1;

	if(*head != NULL) subwindow_data_free(head,tail);

	subwindow_data_insert(head,tail,T_NAME,NULL,NULL,NULL,NULL,XJP_NONE,XJP_NONE,i++);
	subwindow_data_insert(head,tail,"(󥻥 q)",NULL,NULL,xtext_conf_quit,(char *)XJP_CANCEL,XJP_NONE,XJP_NONE,i++);

	if(type == 0){
		subwindow_data_insert(head,tail,"()",NULL,NULL,select_siori_data,(ISIORI_T *)bhead->siori,95,XJP_INT,i++);
		subwindow_data_insert(head,tail,"(ñ) [̾ ̾]",NULL,NULL,select_serch_data,(IBOOK_T *)bhead,0,XJP_INT,i++);
		subwindow_data_insert(head,tail,"(¸޽ )",NULL,NULL,select_person_data,(IBOOK_T *)bhead,0,XJP_INT,i++);
		subwindow_data_insert(head,tail,"-- ¸޽ ̡--",NULL,NULL,NULL,NULL,XJP_NONE,XJP_NONE,i++);

		for(ib=bhead;ib!=NULL;ib=ib->next){
			sw = (sub_window_t *) subwindow_data_alloc();
			sw->line_str = ib->title;
			sw->line_data = ib->filename;
			sw->re_str=ib->fullpath;
			sw->func_data1 = XJP_STR;
			sw->line_no = i++;
			subwindow_data_add(head,tail,sw);
		}

	}else{
		char temp[64];
		IPERSON_T *phead=NULL, *ptail=NULL, *ip;

		ibookGetPersonData(&phead,&ptail,bhead);
		for(ip=phead;ip!=NULL;ip=ip->next){
			sprintf(temp,"-- %s--",ip->person);
			subwindow_data_insert(head,tail,temp,NULL,NULL,NULL,NULL,XJP_NONE,XJP_NONE,i++);
			for(ib=ip->head;ib!=NULL;ib=ib->next){
				sw = (sub_window_t *) subwindow_data_alloc();
				sw->line_str = ib->title;
				sw->line_data = ib->filename;
				sw->re_str=ib->fullpath;
				sw->func_data1 = XJP_STR;
				sw->line_no = i++;
				subwindow_data_add(head,tail,sw);
			}
		}
		person_link_free(phead);
	}

	return 0;
}
int xtextQuitData2Sub(sub_window_t **head,sub_window_t **tail)
{
	if(*head != NULL) subwindow_data_free(head,tail);

	subwindow_data_insert(head,tail,"(XJP λ)",NULL,NULL,xtext_conf_quit,(char *)XJP_OK,XJP_NONE,XJP_NONE,0);
	subwindow_data_insert(head,tail,"(󥻥 q)",NULL,NULL,xtext_conf_quit,(char *)XJP_CANCEL,XJP_NONE,XJP_NONE,1);

	return 0;
}

